/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver;

import java.io.PrintStream;
import java.util.ArrayList;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class Evaluation {
    
    private ArrayList<String> problems = new ArrayList<String>();
    private ArrayList<String> solvers = new ArrayList<String>();
    private ArrayList<Double> times = new ArrayList<Double>();
    private ArrayList<Double> solutions = new ArrayList<Double>();
    private ArrayList<Object> datas = new ArrayList<Object>();
    private ArrayList<Integer> repetitions = new ArrayList<Integer>();
    
    public Evaluation() {
    }
    
    public void reportProgress(String problemName, String solverName, int repetition, double timeTaken, double solutionQuality) {
        reportProgress(problemName, solverName, repetition, timeTaken, solutionQuality, null);
    }
    
    public void reportProgress(String problemName, String solverName, int repetition, double timeTaken, double solutionQuality, Object data) {
        this.problems.add(problemName);
        this.solvers.add(solverName);
        this.times.add(timeTaken);
        this.solutions.add(solutionQuality);
        this.datas.add(data);
        this.repetitions.add(repetition);
    }
    
    public void printCSVHeader(PrintStream out) {
        out.println("Problem,Solver,Repetition,Time,Solution");
    }
    
    public void printCSV(PrintStream out) {
        for (int i = 0; i < times.size(); i++) {
            String problemName = this.problems.get(i);
            String solverName = this.solvers.get(i);
            double time = times.get(i);
            double solution = solutions.get(i);
            int repetition = repetitions.get(i);
            out.println(problemName + "," + solverName + "," + repetition + "," + time + "," + solution);
        }
    }

    void clear() {
        this.problems.clear();
        this.solvers.clear();
        this.times.clear();
        this.solutions.clear();
        this.datas.clear();
        this.repetitions.clear();
    }
}
