/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.problem;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class ConferenceProblem {
    private final Objective objective;
    private final int numSessions;
    private final int tracksInSession;
    private final int papersInSession;
    private final double processingTimeInMinutes;
    private final int totalPapers;
    private String name;

    public ConferenceProblem(Objective objective, int numSessions, int tracksInSession, int papersInSession, double processingTimeInMinutes) {
        this.objective = objective;
        this.numSessions = numSessions;
        this.tracksInSession = tracksInSession;
        this.papersInSession = papersInSession;
        this.processingTimeInMinutes = processingTimeInMinutes;
        this.totalPapers = numSessions * tracksInSession * papersInSession;
    }

    public int getNumSessions() {
        return numSessions;
    }

    public Objective getObjective() {
        return objective;
    }

    public int getPapersInSession() {
        return papersInSession;
    }

    public double getProcessingTimeInMinutes() {
        return processingTimeInMinutes;
    }

    public int getTracksInSession() {
        return tracksInSession;
    }

    public int getTotalPapers() {
        return totalPapers;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }
    
    
    
}
