/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.solution.generator;

import conferencesolver.problem.ConferenceProblem;
import conferencesolver.solution.ConferenceSolution;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.regex.Pattern;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class FileSolutionGenerator extends AbstractSolutionGenerator {
    private final String filename;
    
    public FileSolutionGenerator(String filename) {
        this.filename = filename;
    }
    
    @Override
    public void internalGenerateSolution(ConferenceProblem problem) {
        
        ConferenceSolution solution = new ConferenceSolution(problem);
        
        Pattern p = Pattern.compile("\\|");
        Scanner in = null;
        try {
            in = new Scanner(new File(filename));
        } catch (FileNotFoundException e) {
            System.err.println("File " + filename + " does not exist.");
            System.exit(1);
        }
        int sessionIndex = 0;
        while (in.hasNextLine()) {
            String line = in.nextLine().trim();
            String[] sessions = p.split(line);
            if (!line.equals("")) {
                for (int trackIndex = 0; trackIndex < sessions.length; trackIndex++) {
                    String[] papers = sessions[trackIndex].trim().split(" ");
                    for (int paperIndex = 0; paperIndex < papers.length; paperIndex++) {
                        int paperId = Integer.parseInt(papers[paperIndex]);
                        solution.setPaper(sessionIndex, trackIndex, paperIndex, paperId);
                    }
                }
            }
            sessionIndex++;
        }
        
        update(solution);
    }
    
}
