/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.solution.generator;

import conferencesolver.problem.ConferenceProblem;
import conferencesolver.solution.ConferenceSolution;
import conferencesolver.solution.improver.SolutionImprover;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class OneStart extends AbstractSolutionGenerator {

    private SolutionImprover template;
    private final SolutionGenerator restarter;

    public OneStart(SolutionImprover template, SolutionGenerator restarter) {
        this.template = template;
        this.restarter = restarter;
    }

    @Override
    public void internalGenerateSolution(ConferenceProblem problem) {

        ConferenceSolution start = restarter.generateSolution(problem);

        update(start);

        SolutionImprover searchAgent = template.copy();

        searchAgent.initialize(start);

        while (searchAgent.doStep(start)) {
            start = searchAgent.getCurrentSolution();
            if (!update(start)) {
                return;
            }
        }

        update(start);
    }
}
