/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.solution.generator;

import conferencesolver.solution.improver.SolutionImprover;
import conferencesolver.solution.improver.AdvancedLocalSearch;
import conferencesolver.solution.improver.AbstractSolutionImprover;
import conferencesolver.solution.improver.BasicLocalSearch;
import conferencesolver.problem.ConferenceProblem;
import conferencesolver.solution.ConferenceSolution;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class RandomRestarts extends AbstractSolutionGenerator {

    private final int allowedRestarts;
    private final SolutionImprover template;
    private final SolutionGenerator restarter;
    
    public RandomRestarts(int allowedRestarts, SolutionImprover template, SolutionGenerator restarter) {
        this.allowedRestarts = allowedRestarts;
        this.template = template;
        this.restarter = restarter;
    }

    @Override
    public void internalGenerateSolution(ConferenceProblem problem) {


        for (int i = 0; i < allowedRestarts; i++) {
            ConferenceSolution restart = restarter.generateSolution(problem);

            SolutionImprover searchAgent = template.copy();
            
            searchAgent.initialize(restart);
            
            while (searchAgent.doStep(restart)) {
                restart = searchAgent.getCurrentSolution();
                if (!update(restart)) {
                    return;
                }
            }
            
            if (!update(restart)) {
                return;
            }
        }
    }
}
