/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.solution.generator;

import conferencesolver.problem.ConferenceProblem;
import conferencesolver.solution.ConferenceSolution;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public class RandomSolutionGenerator extends AbstractSolutionGenerator {

    private final Random random;

    public RandomSolutionGenerator() {
        this.random = new Random();
    }

    public RandomSolutionGenerator(Random random) {
        this.random = random;
    }

    @Override
    public void internalGenerateSolution(ConferenceProblem problem) {
        ConferenceSolution solution = new ConferenceSolution(problem);

        int totalPapers = problem.getNumSessions() * problem.getTracksInSession() * problem.getPapersInSession();
        ArrayList<Integer> paperQueue = new ArrayList<Integer>();

        for (int i = 0; i < totalPapers; i++) {
            paperQueue.add(i);
        }

        Collections.shuffle(paperQueue, random);

        int paperCounter = 0;
        for (int s = 0; s < problem.getNumSessions(); s++) {
            for (int t = 0; t < problem.getTracksInSession(); t++) {
                for (int k = 0; k < problem.getPapersInSession(); k++) {
                    solution.setPaper(s, t, k, paperQueue.get(paperCounter));
                    paperCounter++;
                }
            }
        }

        update(solution);
    }
}
