/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package conferencesolver.solution.improver;

import conferencesolver.problem.ConferenceProblem;
import conferencesolver.problem.Objective;
import conferencesolver.solution.ConferenceSolution;

/**
 *
 * @author Michael Brooks <mjbrooks@uw.edu>
 */
public interface SolutionImprover {
    void initialize(ConferenceSolution startingSolution);
    
    /**
     * Returns false if there are no further reasonable steps.
     * @param start
     * @return 
     */
    boolean doStep(ConferenceSolution start);
    
    ConferenceSolution getCurrentSolution();
    double getCurrentQuality();
    
    int getStepsTaken();

    public SolutionImprover copy();

    public void forceObjective(Objective objective);
}
